// Header File
// Created 7/23/2004; 9:26:52 PM
#ifndef DEFS
#define DEFS
#include "extgraph.h"
#define isValid(x,y) (x>9?0:x<0?0:y>9?0:y<0?0:1)
#define isMiss(bord,x,y) (x>9?1:x<0?1:y>9?1:y<0?1:bord[y][x].bits.miss)
#define DrawPeice(x,y) FastFilledRect_Draw_R(GrayGetPlane(LIGHT_PLANE),x,y,x+10,y+10)
#define DrawMiss(x,y)  Sprite8_OR_R(x+2,y+2,8,missSprite,GrayGetPlane(DARK_PLANE))
#define DrawHit(x,y)   Sprite8_OR_R(x+2,y+2,8,hitSprite,GrayGetPlane(DARK_PLANE))
#define DrawSelect(x,y,plane) FastFilledRect_Draw_R(plane,x,y,x+10,y+10)
#define DrawSq(x,y,plane) FastFilledRect_Draw_R(plane,x,y,x+10,y+10);
#define WipeShip(toDraw,bord)  (RemoveShip(toDraw,bord);toDraw->type=NONE)
#define GrayFastFilledRect_Invert_R(x,y,x1,y1) FastFilledRect_Invert_R(GrayGetPlane(DARK_PLANE),x,y,x1,y1);FastFilledRect_Invert_R(GrayGetPlane(LIGHT_PLANE),x,y,x1,y1)
//#define USE_VTI  //makes code that will work well on VTI but wastes battery power
#ifdef USE_VTI
	short D;
	#define Delay() for(D=0;D<1200;D++);
	#warning "creating VTI vertion"
#else
	#define Delay() pokeIO(0x600005,0b11101)
#endif

enum{START_LINK=10,LINK_ACK,LINK_POINT,LINK_QUIT,LINK_READY,LINK_HIT,LINK_MISS,LINK_WON};
enum {EMPTY=0,PEICE=0x20,HIT=0x40,MISS=0x80};
#define SIZE_MASK 0x0F
#define STR_MASK 0xF0
enum {NONE=0,PATROL=0x02,SUB=0x13,DESTROYER=0x23,BATTLESHIP=0x34,CARRIER=0x45};
enum {UP,RIGHT,DOWN,LEFT};
enum {CW,CCW};


typedef  union{
 unsigned char flags;
 struct {
 unsigned char  linked : 1, host : 1;
 }bits;
}LINK;

typedef struct{
	char type;
	short x,y,dir;
}SHIP;

typedef struct{
	short x,y;
}POINT;

typedef struct{//used to store info for the AI
	POINT lastHit,firstHit;
	char hit,dir,hasFH,hitNum;
}AI;

typedef  union{
 unsigned char flags;
 struct {
 unsigned char  miss : 1, hit : 1, ship : 1;
 }bits;
}SQ;

typedef SQ OCEAN[10][10];

typedef SHIP FLEET[5];

extern LINK status;
extern INT_HANDLER save_int_1,save_int_5;
extern void *grid;
extern const char *strs[5];
extern unsigned char missSprite[8];
extern unsigned char hitSprite[8];

void AIMove(OCEAN bord,FLEET ships,AI *save);
void randomLayout(OCEAN bord,FLEET ships);
void AIgame(void)__attribute__((noreturn));
void _main(void)__attribute__((noreturn));
void drawGrid(void);
void darkScreen(void);
short menu(short width,short max,short start);
void notifyLinkHit_or_Miss(POINT move,OCEAN bord);
void receveHit_or_Miss(OCEAN bord,FLEET ships);
void LinkGame(void)__attribute__((noreturn));
void noLinkGame(void)__attribute__((noreturn));
void beginLink(OCEAN myBord,FLEET myShips,OCEAN otherBord);
void endLink(void);
void endGame(void) __attribute__ ((noreturn));
void waitForKey(void);
short PlaceShip(SHIP *toDraw,OCEAN bord);
short CanDrawShip(SHIP *toDraw,short x,short y);
void DrawShip(SHIP *toDraw,void *plane);
//void RemoveShip(SHIP *toDraw,OCEAN bord);
short RotateShip(SHIP *toDraw,short dir);
void DrawBord_NS(OCEAN bord);
void DrawBord(OCEAN bord);
POINT getMove(OCEAN bord);
void switchPlayers(short num);
void getLayout(OCEAN bord,FLEET boats);
short isHit(SHIP *ship,POINT shot);
short isSunk(OCEAN bord,SHIP *ship);
void notifyHit_or_Miss(OCEAN bord,FLEET ships,POINT move);
short hasWon(OCEAN bord,FLEET ships);
#endif